#!/bin/bash

# Delete all data from ust_movements older than 60 days
QUERY=`cat <<EOF
DELETE FROM ust_movements 
WHERE client <= (
    SELECT ust_clientpage.id FROM ust_clientpage
    WHERE ust_clientpage.date < NOW() - INTERVAL 60 DAY 
    ORDER BY date DESC LIMIT 1
);
EOF
`
sh ust_execute_query.sh "$QUERY" "$0 - movements";

# Delete all data from ust_clicks older than 60 days
QUERY=`cat <<EOF
DELETE FROM ust_clicks 
WHERE client <= (
    SELECT ust_clientpage.id FROM ust_clientpage
    WHERE ust_clientpage.date < NOW() - INTERVAL 60 DAY 
    ORDER BY date DESC LIMIT 1
);
EOF
`
sh ust_execute_query.sh "$QUERY" "$0 - clicks";