#!/bin/bash

# Delete all data from ust_partials older than 60 days
QUERY=`cat <<EOF
DELETE FROM ust_partials 
WHERE client <= (
    SELECT ust_clientpage.id FROM ust_clientpage
    WHERE ust_clientpage.date < NOW() - INTERVAL 60 DAY 
    ORDER BY date DESC LIMIT 1
);
EOF
`
sh ust_execute_query.sh "$QUERY" "$0 - partials";

# Delete all data from ust_records older than 60 days
QUERY=`cat <<EOF
DELETE FROM ust_records 
WHERE client <= (
    SELECT ust_clientpage.id FROM ust_clientpage
    WHERE ust_clientpage.date < NOW() - INTERVAL 60 DAY 
    ORDER BY date DESC LIMIT 1
);
EOF
`
sh ust_execute_query.sh "$QUERY" "$0 - records";