#!/bin/bash

# Delete all visitor data older than 1 year
QUERY=`cat <<EOF
DROP PROCEDURE IF EXISTS UST_LIMIT_RECORD_NUMBER;
DELIMITER ;;

CREATE PROCEDURE UST_LIMIT_RECORD_NUMBER()
BEGIN
    DECLARE n INT DEFAULT 0;
    DECLARE i INT DEFAULT 0;
    DECLARE val_sessions_count INT DEFAULT 0;
    DECLARE val_domain VARCHAR(128);
    DECLARE val_record_limit INT DEFAULT 100000;
    SELECT COUNT(*) INTO n FROM ust_limits;
    SET i=0;

    WHILE i < n DO 
        SELECT domain, record_limit INTO val_domain, val_record_limit FROM ust_limits LIMIT i,1;
        SELECT COUNT(*) into val_sessions_count FROM ust_clients WHERE domain = val_domain COLLATE utf8mb4_general_ci;

        IF val_sessions_count > val_record_limit THEN
            SET val_record_limit = val_sessions_count - val_record_limit;
            DELETE FROM ust_clients WHERE domain = val_domain COLLATE utf8mb4_general_ci ORDER BY id ASC LIMIT val_record_limit;
        END IF;

        SET i = i + 1;
    END WHILE;
End;;
DELIMITER ;

CALL UST_LIMIT_RECORD_NUMBER();
EOF
`
sh ust_execute_query.sh "$QUERY" "$0";
