<?php

/**
 * Big thanks to https://www.maxmind.com/ for publicly offering the Reader functions
 * and https://db-ip.com/ for the dbip-city-lite database.
 * 
 * Downloads
 * ----
 * City DB: https://db-ip.com/db/download/ip-to-city-lite
 * Country DB: https://db-ip.com/db/download/ip-to-country-lite
 * 
 * Expected database paths:
 * /server/helpers/geolocation/ip-database.mmdb - COUNTRY DATABASE
 * /server/helpers/geolocation/ip-database-city.mmdb - CITY DATABASE
 **/

if(!class_exists('\MaxMind\Db\Reader')){
    require_once __DIR__ . '/' . 'geolocation/Reader.php';
}

if (!class_exists('MaxMind\Db\Reader\Decoder')) {
    require_once __DIR__ . '/' . 'geolocation/Reader/Decoder.php';
}

if (!class_exists('MaxMind\Db\Reader\InvalidDatabaseException')) {
    require_once __DIR__ . '/' . 'geolocation/Reader/InvalidDatabaseException.php';
}

if (!class_exists('MaxMind\Db\Reader\Metadata')) {
    require_once __DIR__ . '/' . 'geolocation/Reader/Metadata.php';
}

if (!class_exists('MaxMind\Db\Reader\Util')) {
    require_once __DIR__ . '/' . 'geolocation/Reader/Util.php';
}

require_once __DIR__ . '/geolocation/geoip-settings.php';

use MaxMind\Db\Reader;

$mmdb = file_exists(UST_CITY_MMDB_FILE) ? UST_CITY_MMDB_FILE : UST_MMDB_FILE;
$reader = new Reader($mmdb); 

function getCountryFromIP($ip) {
    global $reader;

    try {
        $ipData = $reader->get($ip);
        return $ipData ? $ipData['country']['iso_code'] : 'XX';
    } catch(Exception $e) {
        return 'XX';
    }
}

function getCountryAndCityFromIP($ip) {
    global $reader;
    try {
        $ipData = $reader->get($ip);
        return $ipData ? 
        array(
            'country'=>$ipData['country']['iso_code'], 
            'city'=> isset($ipData['city']) ? $ipData['city']['names']['en'] : null
        )
        : 
        array('country'=>'XX', 'city'=>null);
    } catch(Exception $e) {
        return array('country'=>'XX', 'city'=>null);
    }
}

