<?php

ini_set('display_errors', 1);
error_reporting(E_ALL);

$destination_file = __DIR__ . "/../ust.min.js";
$destination_file_full = __DIR__ . "/../ust-rr.min.js"; // Minified tracker including full session recordings

clearstatcache();
// Regenerate the minified files without permissions if they are missing
// Normally it will be done after setup, before initial login
if (!isset($skipPermissionsCheck)) {
    if (
        file_exists($destination_file) && filesize($destination_file) !== 0 &&
        file_exists($destination_file_full) && filesize($destination_file_full) !== 0
    ) {
        require_once __DIR__ . '/../login.php';
        require_once __DIR__ . '/../permissions.php';
        try {checkPermission('CHANGE_SETTINGS');} catch (Exception $e) {die($e->getMessage());}
    }
}

if(!class_exists('JShrink\Minifier')) {
    require_once __DIR__ . '/../lib/Minifier.php';
}

/*** Minify tracker.js contents and save it as ust.min.js ***/
$filename = __DIR__ . '/../tracker.js';
$contents = file_get_contents($filename);

// Replace settings with the one stored in the $settings variable (should always be set before this file is included)
$contents = str_replace('settings: {}', "settings: JSON.parse('" . json_encode($settings) . "')", $contents);
$minified = \JShrink\Minifier::minify($contents);

file_put_contents($destination_file, $minified);

// Tracker including full session recordings
$filename = __DIR__ . '/../tracker/recorder.js';
$recorder = file_get_contents($filename);
$fullContents = $recorder . PHP_EOL . $contents;
$minified = \JShrink\Minifier::minify($fullContents);
file_put_contents($destination_file_full, $minified);
