<?php

 /*
  * Copyright (C) TIPS4DESIGN SRL - All Rights Reserved
  * Unauthorized copying of this file or any parts of it, via any medium is strictly prohibited
  * Only a valid UXWizz license holder should have access to this file
  * Proprietary and confidential
  * Written by Cristian Buleandră <cristian@uxwizz.com>, Fri 03 December 2021
  */
 
function extractGZIP($inFileName, $outFileName)
{
    $buffer_size = 4096; // read 4kb at a time

    $file = gzopen($inFileName, 'rb');
    $out_file = fopen($outFileName, 'wb');

    // Keep repeating until the end of the input file
    while (!gzeof($file)) {
        // Read buffer-size bytes
        // Both fwrite and gzread and binary-safe
        fwrite($out_file, gzread($file, $buffer_size));
    }

    // Files are done, close files
    fclose($out_file);
    gzclose($file);
}

function downloadExtractGZIP($downloadURL, $fileName)
{
    $dbZip = $fileName . '.gz';
    file_put_contents($dbZip, fopen($downloadURL, 'r'));
    extractGZIP($dbZip, $fileName);
    unlink($dbZip); // Delete archive after unzipping
}

?>